/* premortem.c  */

/* uso i thread quindi definisco i due simboli _THREAD_SAFE e _REENTRANT
   Li ho messi anche nel Makefile per far vedere che si possono mettere li' 
*/
#ifndef _REENTRANT
   #define _REENTRANT
#endif
#ifndef _THREAD_SAFE
  #define _THREAD_SAFE
#endif
/* per usare la funzione usleep bisogna definire il simbolo _DEFAULT_SOURCE
   Ho inserito questo simbolo anche nel Makefile per far vedere 
   che si puo' mettere li'.
*/
#ifndef _DEFAULT_SOURCE
   #define _DEFAULT_SOURCE
#endif

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <pthread.h>

typedef struct s{
	unsigned int indice;
	pthread_t tid;
} S;

#define NUM_THREADS 100

void *func(void *arg)
{
	void *pret; int res; pthread_t tid;
	S *p1, *p=(S*)arg;

	printf("indice %d\n", p->indice);fflush(stdout);
	usleep(1000);

	/* se l'indice ricevuto e' minore di 100 creo un thread figlio */
	if( p->indice < NUM_THREADS ) {
		p1=malloc(sizeof(S));
		if(p1==NULL) { perror("malloc failed"); exit (1); }
		/* passo al thread figlio l'indice ricevuto piu' 1 */
		p1->indice=p->indice+1;
		/* passo al thread figlio il mio thread identifier */
		p1->tid=pthread_self();
		res=pthread_create (&tid, NULL, func, (void*)p1 );
		if (res){ printf("pthread_create() failed: error %i\n", res); exit(1);}

		/* attendo la terminazione del mio thread padre */
		res=pthread_join( p->tid, &pret );
		if(res!=0){ printf("pthread_join() failed: error %i\n",res); exit(1); }
	}
	free(arg);
	pthread_exit (NULL);
}

int main()
{
	int res; pthread_t tid;
	S *p1;

	printf("main indice 0\n"); fflush(stdout);
	usleep(1000);
	p1=malloc(sizeof(S));
	if(p1==NULL) { perror("malloc failed"); exit (1); }
	/* passo al thread figlio indice 1 */
	p1->indice=1;
	/* passo al thread figlio il mio thread identifier */
	p1->tid=pthread_self();
	/* creo il thread figlio */
	res=pthread_create (&tid, NULL, func, (void*)p1 );
	if (res){ printf("pthread_create() failed: error %i\n", res); exit(1);}

	printf("fine main\n"); fflush(stdout);
	
	pthread_exit (NULL);
	return(0);
}

